#
#  Makefile for XFTP/XFTPD
#

BINDIR = /homes/mallman/research/ftp/bin
ETCDIR = /homes/mallman/research/ftp/etc

TOP = ../..

INCDIRS := $(TOP)/include
SRCDIRS := $(TOP)/lib $(TOP)/client $(TOP)/server

INCOPTS := $(patsubst %,-I%,$(INCDIRS))

CPPFLAGS := $(DEFINES) $(INCOPTS)
CFLAGS := -g -DXVER="\"`cat $(TOP)/.version`\""

VPATH := $(SRCDIRS)

LIB := bsdlib.a

all: xftp xftpd

LIBSOURCES := $(notdir $(wildcard $(TOP)/lib/*.c))

LIBOBJECTS := $(addsuffix .o, $(basename $(LIBSOURCES)))

$(LIB): $(LIBOBJECTS)

CLIENTSOURCES := $(notdir $(wildcard $(TOP)/client/*.c))

CLIENTOBJECTS := $(addsuffix .o, $(basename $(CLIENTSOURCES)))

xftp: $(CLIENTOBJECTS) $(LIB) 
	$(LD) $(LDFLAGS) -o $@ $(CLIENTOBJECTS) $(LIB) $(LIB) -ll $(SYSLIBS)

SERVERSOURCES :=  ftpcmd.y $(notdir $(wildcard $(TOP)/server/*.c))

SERVEROBJECTS := $(addsuffix .o, $(basename $(SERVERSOURCES)))

xftpd: $(LIB) $(SERVEROBJECTS)
	$(LD) $(LDFLAGS) -o $@ $(SERVEROBJECTS) $(LIB) $(LIB) -ll $(SYSLIBS)

#
# Rules for cleaning up
#
clean:
	rm -f *.o *.a *.d *.map *.c
	rm -f *.out core

clobber: clean
	rm -f xftp xftpd

install: xftp xftpd
	@echo installing xftp/xftpd
	@cp xftp $(BINDIR)
	@cp xftpd $(ETCDIR)/in.xftpd
	@chmod 755 $(BINDIR)/xftp
	@chmod 755 $(ETCDIR)/in.xftpd

#
# Rule for building each of the libraries
#
%.a:
	$(AR) cr $@ $?
	$(RANLIB) $(RANLIBFLAGS) $@

depend:
	maketd $(CPPFLAGS) $(TOP)/*/*.c
