
/* Clinet header file */
/* Mark Allman */

/* Some definitions... */

#define FALSE 0
#define TRUE  1
#define ECHO_INTERVAL 10

#if defined(__STDC__) || defined(__cplusplus)
#define	__P(protos)	protos		/* full-blown ANSI C */
#else	/* !(__STDC__ || __cplusplus) */
#define	__P(protos)	()		/* traditional C preprocessor */
#endif
#define memmove(d, s, c)        bcopy(s, d, c)

#define MAXRTTS 25

/* Some type definitions... */

#if !defined(NETBSD) 
typedef void (*sig_t) __P((int));
#endif NETBSD

/* Some prototypes... */

char   *getusershell __P((void));
char   *getpass __P((const char *));
int    pclose __P((FILE *));
int    fclose __P((FILE *));
int    xgetopt __P((int, char * const *, const char *));
int    getsubopt __P((char **, char * const *, char **));

/* Some variables... */

extern char *optarg;			/* getopt(3) external variables */
extern int opterr, optind, optopt;
extern char *suboptarg;			/* getsubopt(3) external variable */

#define MAXCNNCTS 60
#define MAXDATA 8192
#define CMDLEN 1000
#define MAXHOLD MAXDATA + sizeof (unsigned long)
#define DEFSOCKBUFSIZE 24576
#define MAXBUFSIZE 256000
#define DEFCNNCTS 4

struct mdata
{
    unsigned long offset;
    char data [MAXDATA];
};

struct cnninfo
{
/*    FILE *dout; */               /* File pointer for connection */
    unsigned short accptd;    /* Whether connection has been accept()ed */
    short ready;              /* Whether or not connection is blocked */
    int size;                 /* Amount left to write to network */
    int pos;                  /* Position to start writing from */
    struct mdata buf;         /* Data to be written to network */
};

struct echopkt
{
    struct timeval tm;
    unsigned int seq;
};

struct holding
{
    unsigned short size;
    struct mdata data;
};

#ifdef SUNOS5
#define __wait wait
union __wait	{
	int	w_status;		/* used in syscall */
	/*
	 * Terminated process status.
	 */
	struct {
#if	defined(vax) || defined(i386)
		unsigned short	w_Termsig:7;	/* termination signal */
		unsigned short	w_Coredump:1;	/* core dump indicator */
		unsigned short	w_Retcode:8;	/* exit code if w_termsig==0 */
#endif
#if	defined(mc68000) || defined(sparc)
		unsigned short	w_Fill1:16;	/* high 16 bits unused */
		unsigned short	w_Retcode:8;	/* exit code if w_termsig==0 */
		unsigned short	w_Coredump:1;	/* core dump indicator */
		unsigned short	w_Termsig:7;	/* termination signal */
#endif
	} w_T;
	/*
	 * Stopped process status.  Returned
	 * only for traced children unless requested
	 * with the WUNTRACED option bit.
	 */
	struct {
#if	defined(vax) || defined(i386)
		unsigned short	w_Stopval:8;	/* == W_STOPPED if stopped */
		unsigned short	w_Stopsig:8;	/* signal that stopped us */
#endif
#if	defined(mc68000) || defined(sparc)
		unsigned short	w_Fill2:16;	/* high 16 bits unused */
		unsigned short	w_Stopsig:8;	/* signal that stopped us */
		unsigned short	w_Stopval:8;	/* == W_STOPPED if stopped */
#endif
	} w_S;
};

#ifndef MAXHOSTNAMELEN
#define     MAXHOSTNAMELEN  64
#endif MAXHOSTNAMELEN

#endif SUNOS5
