
/* Server header file */
/* Mark Allman */

/* Some definitions... */

#define LINE_MAX     2048
#define CMDLEN       1000
#define	LOG_FTP		(11<<3)	/* ftp daemon */
#define L_SET        SEEK_SET
#define L_INCR       SEEK_CUR
#if defined(__STDC__) || defined(__cplusplus)
#define	__P(protos)	protos		/* full-blown ANSI C */
#else	/* !(__STDC__ || __cplusplus) */
#define	__P(protos)	()		/* traditional C preprocessor */
#endif
#define  _PATH_WTMP      "/var/log/wtmp"

/* Some type definitions... */

#if defined(SUNOS4)
typedef int sig_atomic_t;
#endif

/* Some variables... */

extern char *optarg;			/* getopt(3) external variables */
extern int opterr, optind, optopt;
extern char *suboptarg;			/* getsubopt(3) external variable */

/* Some function prototypes.... */

int    xgetopt __P((int, char * const *, const char *));
int    getsubopt __P((char **, char * const *, char **));
char   *getusershell __P((void));
char   *crypt __P((const char *, const char *));
int    fclose __P((FILE *));
char   *getwd __P((char *));                   /* obsoleted by getcwd() */


#define MAXCNNCTS 60
#define MAXDATA 8192
#define DEFSOCKBUFSIZE 24576
#define MAXBUFSIZE 256000

struct mdata
{
    unsigned long offset;
    char data [MAXDATA];
};

#define FALSE  0
#define TRUE   1

struct holding
{
    unsigned short size;
    struct mdata data;
};

#ifdef IRIX
struct  dirent {
        off_t           d_off;          /* offset of next disk dir entry */
        unsigned long   d_fileno;       /* file number of entry */
        unsigned short  d_reclen;       /* length of this record */
        unsigned short  d_namlen;       /* length of string in d_name */
        char            d_name[255+1];  /* name (up to MAXNAMLEN + 1) */
};

typedef struct
	{
	int		dd_fd;		/* file descriptor */
	int		dd_loc;		/* offset in block */
	int		dd_size;	/* amount of valid data */
	char		*dd_buf;	/* directory block */
	}	DIR;			/* stream data from opendir() */

struct utmp {
	char	ut_line[8];		/* tty name */
	char	ut_name[8];		/* user id */
	char	ut_host[16];		/* host name, if remote */
	long	ut_time;		/* time on */
};

#define sigmask(m)     (1 << ((m)-1))

#endif

struct cnninfo
{
/*    FILE *dout; */               /* File pointer for connection */
    unsigned short accptd;    /* Whether connection has been accept()ed */
    short ready;              /* Whether or not connection is blocked */
    int size;                 /* Amount left to write to network */
    int pos;                  /* Position to start writing from */
    struct mdata buf;         /* Data to be written to network */
};
